<?php


namespace MirfalahTech\Swift;


use GuzzleHttp\Client;
use GuzzleHttp\RequestOptions;
use Swift_Events_EventListener;
use Swift_Mime_SimpleMessage;
use Swift_Transport;

class MirfalahTransport implements Swift_Transport
{
    /**
     * @var string
     */
    protected $apiKey;

    /**
     * @var string
     */
    protected $secret;

    /**
     * @var string
     */
    protected $endpoint;

    /**
     * @var Client
     */
    protected $client;

    public function __construct($apiKey, $secret, $endpoint)
    {
        $this->apiKey = $apiKey;
        $this->secret = $secret;
        $this->endpoint = $endpoint;
        $this->client = new Client();
    }

    /**
     * @inheritDoc
     */
    public function isStarted()
    {
    }

    /**
     * @inheritDoc
     */
    public function start()
    {
    }

    /**
     * @inheritDoc
     */
    public function stop()
    {
    }

    /**
     * @inheritDoc
     */
    public function ping()
    {
    }

    /**
     * @inheritDoc
     */
    public function send(Swift_Mime_SimpleMessage $message, &$failedRecipients = null)
    {
        $body = (string) $message;
        $this->client->post($this->endpoint, [
            RequestOptions::QUERY => [
                'apiKey' => $this->apiKey,
                'signature' => hash_hmac('sha1', $body, $this->secret),
            ],
            RequestOptions::BODY => $body,
        ]);
    }

    /**
     * @inheritDoc
     */
    public function registerPlugin(Swift_Events_EventListener $plugin)
    {
    }
}